#!/usr/bin/python
import os,re,string,StringIO,myFunct
insertDict={}  # keeps track to which html files  should be examples inserted
transtable=string.maketrans(' \/:(){}[]<>=*+?!#.,0123456789','ABCDEFGHIJKLMNOPQRSTnnnnnnnnnn') #to match filenames


def addToInsertDict(regexp,id):
    global insertDict, transtable
    meta=re.compile(r"\\[A-Za-wyz]").findall(regexp)
    meta.extend(re.compile(r"\\\d{3}").findall(regexp))  #octal
    meta.extend(re.compile(r"\\x[1-9A-E]{2}").findall(regexp))  #hexadecimal
    meta.extend(re.compile("[\*\+\?]\?").findall(regexp))
    meta.extend(re.compile("[^\?\*\+\}\(]([\*\+\?])(?!\?)").findall(regexp))
    meta.extend(re.compile("\{[\d,]+\}\?").findall(regexp))
    meta.extend(re.compile("\{[\d,]+\}(?!\?)").findall(regexp))
    meta.extend(re.compile("\(\?=").findall(regexp))
    meta.extend(re.compile("\(\?!").findall(regexp))
    meta.extend(re.compile("\(\?i\)").findall(regexp))
    for item in meta:
        item=string.translate(item,transtable)
        item=re.compile("n+Tn+").sub('nTm',item)         #catch cases like {2,5}?
        item=re.compile("n+").sub('n',item)         #catch cases like {2,}?
        if not(insertDict.has_key(item)): insertDict[item]=[id]
        else: insertDict[item].append(id)

def span(match):
    return "<span class='hit'>"+match.group(0)+"</span>"

def example(text, regexp, id):
    text1=re.compile(regexp,re.S).sub(span,text,1)
    text2=re.compile(regexp,re.S).sub(span,text)

    out=open("../OutputExamples/example_"+id+".html","w")
    out.write("""
    <html><head><meta http-equiv='Content-Type' content='text/html; charset=utf-8'>
    <link rel='stylesheet' type='text/css' href='../CSS/style.css'>
    <title>RE Reference - example</title>
    </head><body><table width='85%' border='1' class='regexp' cellpadding='8'>
    <tr><td class='title'>Regular expression</td></tr>
    <tr><td class='regexp'>
    """)
    out.write(regexp+"</td></tr>")
    out.write("<tr><td class='result'>"+text1+"</td></tr>")
    out.write("<tr><td class='result'>"+text2+"</td></tr>")
    out.write("</table></body></html>")
    out.close()

def tagcontents(name):
    return "<"+name+"\s*>\s*(.*?)\s*</"+name+"\s*>"

def process(data,id):
    text = string.strip(re.compile(tagcontents("text"),re.S).search(data).group(1))
    lst=re.compile(tagcontents("re"),re.S).findall(data)

    for i in range(len(lst)):
        identity=id+"_"+str(i+1)
        example(text,lst[i],identity)
        addToInsertDict(lst[i],identity)
        
        
def run():
    files=os.listdir("../Sources")
    for file in files:
        hit = re.compile("source(\d+).xml\Z").match(file)
        if not(hit): continue

        input=open("../Sources/"+file)
        process(input.read(),hit.group(1))
        input.close()

def htmlInsert():
    global insertDict, exampleDict
    for item in insertDict.items():
        fn = item[0]
        if re.match('Bx',fn): fn='BxnB'
        if re.match('EPM',fn): fn='EPMpatternF'
        if re.match('EPQ',fn): fn='EPQpatternF'
        if re.match('EPiF',fn): fn='EPimsx-imsxF'

        if re.compile("[a-z]").match(fn[1:2]) or fn[1:2]=='':
            fn="lower_"+fn
            
        file = "../Output/"+fn+".html"
        frame = "../Output/"+fn+"_frame.html"
        input=open(file)
        data=input.read()
        input.close()
        lst=myFunct.uniqueSortedList(item[1])
        insert=''
        for i in range(len(lst)):
            href="../OutputExamples/example_"+lst[i]+".html"
            if i==0:
                input=open(frame)
                t=input.read()
                input.close
                t=re.compile("frameSource\.html").sub(href,t)
                output=open(frame,"w")
                output.write(t)
                output.close()
                
            insert=insert+' '+"<a target='example' href='"+href + "'>"+string.zfill(i+1,2)+"</a>"

        data = re.compile("<\!--AllStart-->.*?<\!--AllEnd-->",re.S).sub("<!--AllStart-->"+insert+"<!--AllEnd-->",data)
        out=open(file,"w")
        out.write(data)
        out.close()


    
###############################################################            
run()
htmlInsert()

open("../Output/frameSource.html","w").write("<html><head><link rel='stylesheet' type='text/css' href='../CSS/style.css'> </head><body></body></html>")

print "O.K."






